﻿//
// Copyright 2005, Captator - de danske .NET eksperter
//
// Denne demo er lavet i forbindelse med artiklen: "Generics",
// læs artiklen i klummen ".Henrik om .NET" - på www.captator.dk.
//
// Den følgende kode skal blot opfattes som eksempler, der illustrerer nogle af de muligheder, der ligger i brugen af generics.
//
// Koden er til fri afbenyttelse, finder du en fejl eller har du kommentarer til forbedringer så
// sagsøg os ikke ;->, men send i stedet en mail til info@captator.dk

namespace GenericBubbleSort
{
	static class SortUtil
	{
		public static void SortIntArray(int[] numbers)
		{
			for (int i = 0; i < numbers.Length - 1; i++)
			{
				for (int j = 0; j < numbers.Length - 1 - i; j++)
				{
					if (numbers[j + 1] < numbers[j])
					{
						Swap(ref numbers[j], ref numbers[j + 1]);
					}
				}
			}
		}

		public static void SortIComparableArray(System.IComparable[] numbers)
		{
			for (int i = 0; i < numbers.Length - 1; i++)
			{
				for (int j = 0; j < numbers.Length - 1 - i; j++)
				{
					if (numbers[j + 1].CompareTo(numbers[j]) < 0)
					{
						Swap(ref numbers[j], ref numbers[j + 1]);
					}
				}
			}
		}

		public static void GenericSortIComparable<T>(T[] numbers) where T : System.IComparable
		{
			for (int i = 0; i < numbers.Length - 1; i++)
			{
				for (int j = 0; j < numbers.Length - 1 - i; j++)
				{
					if (numbers[j + 1].CompareTo(numbers[j]) < 0)
					{
						Swap<T>(ref numbers[j], ref numbers[j + 1]);
					}
				}
			}
		}

		public static void GenericSortIComparableOfT<T>(T[] numbers) where T : System.IComparable<T>
		{
			for (int i = 0; i < numbers.Length - 1; i++)
			{
				for (int j = 0; j < numbers.Length - 1 - i; j++)
				{
					if (numbers[j + 1].CompareTo(numbers[j]) < 0)
					{
						Swap<T>(ref numbers[j], ref numbers[j + 1]);
					}
				}
			}
		}

		public static void Swap(ref int obj1, ref int obj2)
		{
			int tmp = obj2;
			obj2 = obj1;
			obj1 = tmp;
		}

		public static void Swap(ref System.IComparable obj1, ref System.IComparable obj2)
		{
			System.IComparable tmp = obj2;
			obj2 = obj1;
			obj1 = tmp;
		}

		public static void Swap<T>(ref T obj1, ref T obj2)
		{
			T tmp = obj2;
			obj2 = obj1;
			obj1 = tmp;
		}
	}
}